#include <stdio.h>
#include <ctype.h>
#include <proto.h>

/************************************************************************\
*
* Local headers to global headers.
*
* This program will convert all lines of the form '#include "..."' into
* '#include <[prefix]...>'. The main use for this is to let library
* source code make local includes for compilation and then at installation
* convert all local include files to global include files for the library.
*
* This can probably be done with a shell script but I don't know how and
* I don't want to spend time learning how.
*
* Command line must be a list of files with a desitination library last.
* A prefix is specified by a -p option.
*
* $Copyright: (C) 1997 by Gran Gustafsson $ 
*
\************************************************************************/

/* Line buffer */
char buf[2048];
char *match="#include";

/************************************************************************\
*
* Convert line with '#include' directive.
*
\************************************************************************/
void ConvertLine(FILE *ofh,char *pref)
{
	int n;
	
	for(n=0; match[n]; n++)
	{
		if(match[n]!=buf[n])
		{
			fputs(buf,ofh);
			return;
		}
	}
	while(isspace(buf[n]))
		n++;
	if(buf[n]!='"')
	{
		fputs(buf,ofh);
		return;
	}
	fprintf(ofh,"#include <%s",pref);
	n++;
	while(buf[n]!='"')
	{
		fputc(buf[n],ofh);
		n++;
	}
	fputc('>',ofh);
	fputs(&buf[n+1],ofh);
}


/************************************************************************\
*
* Main function of program.
*
\************************************************************************/
int main(int argc,char **argv)
{
	int n;
	char *pre=NULL;
	FILE *ifh,*ofh;
	
	if(((strcmp(argv[1],"-p")!=0) && (argc<3)) || (argc<5))
	{
		printf("Usage: %s [-p <prefix>] <infile> ... <outdir>\n",argv[0]);
		exit(0);
	}
	if(strcmp(argv[1],"-p")==0)
	{
		pre=argv[2];
		n=3;
	}
	else
		n=1;
	for(; n<argc-1; n++)
	{
		if(!(ifh=fopen(argv[n],"r")))
		{
			fprintf(stderr,"Error: No input file '%s'\n",argv[n]);
			exit(1);
		}
		strcpy(buf,argv[argc-1]);
		strcat(buf,"/");
		strcat(buf,argv[n]);
		if(!(ofh=fopen(buf,"w")))
		{
			fprintf(stderr,"Error: No output file '%s'\n",buf);
			exit(1);
		}
		while(fgets(buf,2048,ifh))
		{
			if(buf[0]=='#')
				ConvertLine(ofh,pre ? pre : (char *)NULL);
			else
				fputs(buf,ofh);
		}
		fclose(ifh);
		fclose(ofh);
	}
	return(0);
}

